#pragma once

class ATL_NO_VTABLE CContextMenu : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CContextMenu, &CLSID_ContextMenu>,
	public IShellExtInit,
	public IContextMenu3
{
public:
	CContextMenu () :
		m_uOurItemID (0),
		m_pIImgCtx (NULL)
	{
		m_ThumbSize.cx = m_ThumbSize.cy = 150;	//    cx == cy
		m_ImgSize.cx = 0;
		m_ImgSize.cy = 0;
		m_ItemSize.cx = 0;
		m_ItemSize.cy = 0;
		m_PicSize.cx = 0;
		m_PicSize.cy = 0;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_CONTEXTMENU)

BEGIN_COM_MAP(CContextMenu)
	COM_INTERFACE_ENTRY(IShellExtInit)
	COM_INTERFACE_ENTRY(IContextMenu)
	COM_INTERFACE_ENTRY(IContextMenu2)
	COM_INTERFACE_ENTRY(IContextMenu3)
END_COM_MAP()

DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return CoCreateInstance (CLSID_IImgCtx, NULL, CLSCTX_ALL,
			IID_IImgCtx, (void**) &m_pIImgCtx);
	}
	
	void FinalRelease() 
	{
		if (m_pIImgCtx) {
			m_pIImgCtx->Release ();
			m_pIImgCtx = NULL;
		}
	}

public:
	// IShellExtInit
	STDMETHOD(Initialize)(LPCITEMIDLIST, LPDATAOBJECT, HKEY);

	// IContextMenu
	STDMETHOD(QueryContextMenu)(HMENU, UINT, UINT, UINT, UINT);
	STDMETHOD(InvokeCommand)(LPCMINVOKECOMMANDINFO);
	STDMETHOD(GetCommandString)(UINT, UINT, UINT*, LPSTR, UINT);

	// IContextMenu2
	STDMETHOD(HandleMenuMsg)(UINT, WPARAM, LPARAM);

	// IContextMenu3
	STDMETHOD(HandleMenuMsg2)(UINT, WPARAM, LPARAM, LRESULT*);

protected:
	CString		m_szFile;			//  
	UINT		m_uOurItemID;		//   
	IImgCtx*	m_pIImgCtx;			//      
	SIZE		m_ThumbSize;		//  
	SIZE		m_ImgSize;			//   
	SIZE		m_ItemSize;			//    (> m_ThumbSize)
	SIZE		m_PicSize;			//      

	// Helper functions for handling the menu-related messages.
	STDMETHOD(MenuMessageHandler)(UINT, WPARAM, LPARAM, LRESULT*);
	STDMETHOD(OnMeasureItem)(MEASUREITEMSTRUCT*, LRESULT*);
	STDMETHOD(OnDrawItem)(DRAWITEMSTRUCT*, LRESULT*);
};

OBJECT_ENTRY_AUTO(__uuidof(ContextMenu), CContextMenu)
